subroutine Aggregate

use global
use mod_functions

implicit none
real(8):: ctmp
real(8):: H_realtmp, Xh_realtmp, K_realtmp, ddeltaktmp, ddeltahtmp
integer:: i1, i2

print*, 'aggregation of K and L using simulation'


K_real(:,1)=Kss
H_real(:,1)=Hss
Xh_real(:,1)=Xhss

do i1=2,T+1

    !$OMP PARALLEL PRIVATE(i2,H_realtmp,Xh_realtmp,K_realtmp)
        
    !$OMP DO
    
    do i2=1,N
        K_realtmp=interp2nu(dimgridk,dimgridh,kgrid,hgrid,polk(:,:,A_index(i2)),K_real(i2,i1-1),H_real(i2,i1-1))
        K_realtmp=max(K_realtmp,0.0d0)
        K_real(i2,i1)=K_realtmp
        H_realtmp=interp2nu(dimgridk,dimgridh,kgrid,hgrid,polh(:,:,A_index(i2)),K_real(i2,i1-1),H_real(i2,i1-1))
        H_realtmp=eta_real(i2,i1)*H_realtmp
        H_realtmp=max(H_realtmp,0.01d0)
        H_real(i2,i1)=H_realtmp
        Xh_realtmp=interp2nu(dimgridk,dimgridh,kgrid,hgrid,polxh(:,:,A_index(i2)),K_realtmp,H_realtmp)
        Xh_realtmp=max(Xh_realtmp,0.0d0)
        Xh_real(i2,i1)=Xh_realtmp
        Welfare_real(i2,i1-1) = (1.0d0/(1.0d0-sigma))*((1.0d0+r)*K_real(i2,i1-1) &
         & +H_real(i2,i1-1)*w-K_real(i2,i1)-Xh_real(i2,i1-1))**(1.0d0-sigma)
    enddo
    
    
   !$OMP END DO
        
   !$OMP END PARALLEL
    
enddo

welfare = (1.0d0/(1.0d0-beta))*sum(Welfare_real(:,TT+1:T))/real(N*(T-TT))

!====================================
!compute ddeltak and ddeltah
!====================================

!$OMP PARALLEL PRIVATE(i1,i2,ctmp,ddeltaktmp)

!$OMP DO

do i1=1,T
    do i2=1,N
        ctmp = (1.0d0+r)*K_real(i2,i1)+w*H_real(i2,i1)-K_real(i2,i1+1)-Xh_real(i2,i1)
        C_real(i2,i1) = ctmp
        ddeltaktmp=ctmp**(-sigma)*(K_real(i2,i1)/Knew-H_real(i2,i1)/Hnew) 
        ddeltak_real(i2,i1)=ddeltaktmp
    enddo
enddo

!$OMP END DO

!$OMP END PARALLEL


Knew=sum(K_real(:,TT+1:T))/real(N*(T-TT))
Hnew=sum(H_real(:,TT+1:T))/real(N*(T-TT))

print*,'Knew=', Knew
print*,'Hnew=', Hnew

KLrationew=Knew/Hnew


rnew=B*alpha*KLrationew**(alpha-1.0d0)-deltak

ddeltaknew=alpha*(alpha-1.0d0)*KLratio**(alpha-1.0d0)*sum(ddeltak_real(:,TT+1:T))/real(N*(T-TT))
ddeltahnew=-1.0d0*KLratio*ddeltaknew

end subroutine