subroutine GIni

use global
use qsort_c_module

integer:: ind(N), i1
real:: wealth(N), earning(N), lastH(N)

real(8):: numerator, denominator, meanwealth, meanwealthsq, varwealth

do i1=1,N
    ind(i1)=i1
enddo

wealth=K_real(:,T)
earning=H_real(:,T)

call QsortC(wealth)
call QsortC(earning)

numerator=0.0d0
do i1=1,N
    numerator=numerator+real(N+1-i1)*wealth(i1)
enddo

denominator=0.0d0
do i1=1,N
    denominator=denominator+wealth(i1)
enddo

KGini=real(N+1)/real(N)-2.0d0*numerator/(denominator*real(N))

numerator=0.0d0
do i1=1,N
    numerator=numerator+real(N+1-i1)*earning(i1)
enddo

denominator=0.0d0
do i1=1,N
    denominator=denominator+earning(i1)
enddo

HGini=real(N+1)/real(N)-2.0d0*numerator/(denominator*real(N))

print*, 'KGini=',KGini, ' HGini=', HGini

lastH=H_real(:,T)
call QsortC(lastH)


!========================
! compute CV (coefficient of variation)

meanwealth=sum(wealth)/real(N)
meanwealthsq=sum(wealth**2.0)/real(N)
!print*, 'meanwealth=', meanwealth, 'meanwealthsq=', meanwealthsq

varwealth=meanwealthsq-meanwealth**2.0d0
!print*, 'varwealth=', varwealth
CV=sqrt(varwealth)/meanwealth

print*, 'CV=', CV


open(unit=70,file='Gini.txt',status='replace')
     write(70,*) 'KGini=', KGini, ' HGini=', HGini
close(70)

open(unit=81,file='lastK.txt',status='replace')
     write(81,'(1f20.10)') wealth
close(81)

open(unit=82,file='lastH.txt',status='replace')
     write(82,'(1f20.10)') lastH
close(82)   

end subroutine



  