subroutine corrkh

use global

implicit none

integer:: i1
real:: wealth(N), earning(N)
real(8):: meanksq, meank, meanhsq, meanh, meankh, cov, vark, varh

! compute last period only
wealth=K_real(:,T)
earning=H_real(:,T)

! compute means
meanksq=0.0d0
do i1=1,N
    meanksq=meanksq+wealth(i1)**2.0d0/real(N)
enddo

meank=0.0d0
do i1=1,N
    meank=meank+wealth(i1)/real(N)
enddo

meanhsq=0.0d0
do i1=1,N
    meanhsq=meanhsq+earning(i1)**2.0d0/real(N)
enddo

meanh=0.0d0
do i1=1,N
    meanh=meanh+earning(i1)/real(N)
enddo

meankh=0.0d0
do i1=1,N
    meankh=meankh+wealth(i1)*earning(i1)/real(N)
enddo

! compute cov and var
cov=meankh-meank*meanh
vark=meanksq-meank**2.0d0
varh=meanhsq-meanh**2.0d0

!compute corr
corr_kh=cov/(sqrt(vark)*sqrt(varh))

print*, 'corr=',corr_kh

open(unit=90,file='corr.txt',status='replace')
     write(90,*) 'corr=', corr_kh    
close(90)

end subroutine