subroutine genetashock

use global
use probability

real(8):: mu_eta, mintheta, maxtheta, ttheta(ngrid), midtheta(ngrid-1), cumprobtheta(ngrid)
integer:: i1, i2, eta_min(1), etaind

mu_eta=-0.5*sigma_eta**2.0
mintheta=mu_eta-2.0*sigma_eta
maxtheta=mu_eta+2.0*sigma_eta

do i1=1,ngrid
    ttheta(i1)=mintheta+((maxtheta-mintheta)/(ngrid-1.0))*(i1-1)
enddo

do i1=1,ngrid-1
    midtheta(i1)=(ttheta(i1+1)+ttheta(i1))/2.0
enddo

do i1=1,ngrid-1
    cumprobtheta(i1)=NORMCDF((midtheta(i1)-mu_eta)/sigma_eta,0.0d0,1.0d0)
enddo
cumprobtheta(ngrid)=1.0

etashockprob(1)=cumprobtheta(1)
do i1=2,ngrid
    etashockprob(i1)=cumprobtheta(i1)-cumprobtheta(i1-1)
enddo

etashock=dexp(ttheta)

!print*, 'etashock='
!print*, etashock
!print*, 'etashockprob='
!print*, etashockprob

do i1=1,N
    do i2=1,T+1
        eta_min=minloc(abs(cumprobtheta-ushock(i1,i2)))
        etaind=eta_min(1)
        if (ushock(i1,i2) > cumprobtheta(etaind)) etaind=etaind+1
        eta_real(i1,i2)=etashock(etaind)
    enddo
enddo


open(unit=11, file='etashock.txt')
  write(11,'(1f14.7)') etashock
close(11)

open(unit=12, file='etashockprob.txt')
  write(12,'(1f14.7)') etashockprob
close(12)

end subroutine