module global
! parameters
!==============================================================================================
real(8), parameter:: sigma=2.0d0, alpha=0.36d0, deltak=0.08d0, phi=0.4d0, deltah=0.04d0, sigma_eta=0.111d0 
real(8):: beta
!==============================================================================================

!=================================================================================================================
real(8):: sigma_A 
!=================================================================================================================

!calibration target
!==============================================================
real(8), parameter:: rtarget=0.04    , Hginitarget=0.60
!==============================================================

! tolerances for ssolver and policy function convergence
real(8), parameter:: tol1=10.E-10, tol2=10.E-6, tol3=10.E-6    ! tol1: for ssolver,  tol2: for policy function convergence

! global variables 
real(8):: mu_A, meanA, w, r,  B, rnew, Knew, Hnew, KLratio, KLrationew, ddeltaknew, ddeltahnew


! grid of k and h   &  grid of shock and ability
!=======================================================
real(8), parameter:: hmin=0.1
real(8), parameter:: kmin=0.0
integer, parameter:: dimgridk=250,dimgridh=500, ngrid=3
!===========================================================
real(8):: hmax, kmax

real(8), allocatable, dimension(:):: kgrid, hgrid
real(8):: Ability(ngrid), etashock(ngrid),etashockprob(ngrid)
real(8), allocatable, dimension(:,:,:):: polk, polxh, polh, polxhendold, dval1, dval2, theta


!steady-state
real(8):: Hss, Xhss, rss, Kss, wss, Yss

!checking gap
integer, parameter:: kchk1=3, kchk2=dimgridk-3, hchk=dimgridh-3

!simulation for aggregation
integer, parameter:: T=5000, N=10000, TT=2000, NT=N*(T+1)
real(8):: eta_real(N,T+1)
real(8),allocatable, dimension(:,:) :: K_real, H_real, Xh_real, C_real
real(8),allocatable, dimension(:,:) :: Welfare_real, ddeltak_real, ddeltah_real
integer:: A_index(N)
real(8):: ushock(N,T+1)
real(8):: KGini, HGini, CV, corr_kh
real(8):: welfare
real(8):: relative_k05, relative_h05, relative_k10, relative_h10, relative_k20, relative_h20

end module