program humanK

use global
use mod_functions

implicit none

real(8):: gapr
real(8):: ctmp, cbdd, ss1
integer:: j1, j2, j3
integer:: go_on_price, iter_price, i1, i2
real(8):: DSEED, ushocktmp(NT), maxK_real, maxH_real, mean_Kreal(T), mean_Hreal(T)

real(8):: A,k,h
real(8), allocatable, dimension(:):: polktmp, polxhtmp, polxhendoldtmp, polhtmp, dval1tmp, dval2tmp
integer:: dimgridkpre, dimgridhpre
real(8), allocatable, dimension(:):: kgridpre, hgridpre
real(8), allocatable, dimension(:,:,:):: polhpre, polkpre, polxhpre, dval1pre, dval2pre, polxhendoldpre

real(8):: gridparam

integer:: go_on_calib, iter_cal
real(8):: gapcal, gapHgini, gapreq
real(8):: rho

!=========================================
! initial guess for sigmaA and beta
!=========================================
beta=0.94055d0      
sigma_A=0.148d0
!========================================

! shock generation for the eta shock
DSEED=3243090.0D+00
call GGUBS(DSEED,NT,ushocktmp)
ushock=reshape(ushocktmp,(/N, T+1/))
print*, 'shock generated'

allocate(K_real(N,T+1))
allocate(H_real(N,T+1))
allocate(Xh_real(N,T+1))
allocate(C_real(N,T))
allocate(Welfare_real(N,T))
allocate(ddeltak_real(N,T))
allocate(ddeltah_real(N,T))

call genetashock


allocate(kgrid(dimgridk),hgrid(dimgridh))

allocate(polktmp(dimgridk*dimgridh*ngrid))
allocate(polxhtmp(dimgridk*dimgridh*ngrid)) 
allocate(polxhendoldtmp(dimgridk*dimgridh*ngrid))
allocate(polhtmp(dimgridk*dimgridh*ngrid))
allocate(dval1tmp(dimgridk*dimgridh*ngrid)) 
allocate(dval2tmp(dimgridk*dimgridh*ngrid))
        
print*, 'grid generation for previous result'
! loading previous result
hmax=18.0  !30
kmax=300.0  !400
!call getgrid
gridparam = 0.4d0  !k = 1 is linear, k = 0 is L-shaped
call PowerSpacedGrid (dimgridk,gridparam,kmin,kmax,kgrid)
call PowerSpacedGrid (dimgridh,gridparam,hmin,hmax,hgrid)
        
open(unit=1, file='kgrid.txt')
    write(1,'(1f14.7)') kgrid
close(1)  

open(unit=2, file='hgrid.txt')
    write(2,'(1f14.7)') hgrid
close(2)  
        
open(unit=99,file='polh.txt',status='old')
    read(99,*) polhtmp     
close(99)
open(unit=100,file='polk.txt',status='old')
    read(100,*) polktmp     
close(100)
open(unit=101,file='polxh.txt',status='old')
    read(101,*) polxhtmp     
close(101)
open(unit=102,file='dval1.txt',status='old')
    read(102,*) dval1tmp     
close(102)
open(unit=102,file='dval2.txt',status='old')
    read(102,*) dval2tmp     
close(102)
open(unit=104,file='polxhendold.txt',status='old')
    read(104,*) polxhendoldtmp     
close(104)
        
allocate(polk(dimgridk,dimgridh,ngrid),polxh(dimgridk,dimgridh,ngrid))
allocate(polh(dimgridk,dimgridh,ngrid),polxhendold(dimgridk,dimgridh,ngrid))
allocate(dval1(dimgridk,dimgridh,ngrid),dval2(dimgridk,dimgridh,ngrid))

polh=RESHAPE (polhtmp, (/dimgridk, dimgridh, ngrid/))
polk=RESHAPE (polktmp, (/dimgridk, dimgridh, ngrid/))
polxh=RESHAPE (polxhtmp, (/dimgridk, dimgridh, ngrid/))
dval1=RESHAPE (dval1tmp, (/dimgridk, dimgridh, ngrid/))
dval2=RESHAPE (dval2tmp, (/dimgridk, dimgridh, ngrid/))
polxhendold=RESHAPE (polxhendoldtmp, (/dimgridk, dimgridh, ngrid/))


!==================================================================
!========================
! initial KL ratio       !
!========================
KLratio = ((0.04d0+deltak)/alpha)**(1.0d0/(alpha-1.0d0))
!======================================================================
!======================================================================

open(unit=51,file='logfile.txt',status='replace')
print*, 'Starting calibration '
go_on_calib=1
iter_cal=0
gapcal=100.0

do while (go_on_calib==1)

    iter_cal=iter_cal+1
    print*,'================= iter_calib=', iter_cal,' =================='
    write(51,*) '================= iter_calib=', iter_cal,' =================='
    
    print*,'beta=', beta, 'sigma_A=', sigma_A
    write(51,*) 'beta=', beta, 'sigma_A=', sigma_A

    print*, 'Start solving for meanA'
    call meanAsolver
    print*,''
    print*,'meanA=', meanA
    print*, ''
    write(51,*) 'meanA=', meanA
    
    ! mean of log(A)
    mu_A=dlog(meanA)-0.5*sigma_A**2.0
    call steadystate
    call genability

    print*, 'Start the iteration for market clearing (stationary equilibrium)'
    !pause

    go_on_price=1
    iter_price=0
    gapr=100.0

    do while (go_on_price ==1)     !price iteration

        iter_price=iter_price+1
    
        print*,'================= iter_price=', iter_price,' =================='
        write(51,*) '================= iter_price=', iter_price,' =================='

        !compute prices 
        w=B*(1.0d0-alpha)*KLratio**alpha
        r=B*alpha*KLratio**(alpha-1.0d0)-deltak

        print*, 'prices','w=', w, ' r=', r 
        write(51,*) 'prices','w=', w, ' r=', r 

        call HHproblem
        call Aggregate
    
        print*, 'KLratio=',KLratio
        print*, 'KLrationew=',KLrationew

        gapr=dabs(r-rnew)
    
        print*, 'gapr=', gapr
    
        !go_on_price=0
        if (gapr<tol3) then
            go_on_price=0
        endif

        KLratio=0.80*KLratio+0.20*KLrationew
    
    enddo   ! price iteration 
    
    print*,'stationary equilibrium price converged'
    
    print*, 'equilibrium r=', r
    print*, 'equilibrium w=', w
    print*, 'equilibrium K=', Knew 
    print*, 'equilibrium H=', Hnew
    
    ! computation of GIni coefficients
    print*, 'Computing Gini indenxes'
    call Gini
    print*, 'Computing correlation'
    call corrkh
    
    ! check if gapcal is small enough
    gapHgini=dabs(Hginitarget-Hgini)
    gapreq=dabs(rtarget-r)
    
    print*, 'gapHgini=', gapHgini
    print*, 'gapreq=', gapreq
    write(51,*) 'gapHgini=', gapHgini
    write(51,*) 'gapreq=', gapreq
    
    
    if (gapHgini < 0.0005d0 .and. gapreq < 0.00001d0) then
        go_on_calib=0
    else
 
    !===============================
    !updating sigmaeta and beta
    !===============================
    rho=1.0d0/beta-1.0d0
    rho=rho-0.5d0*(r-rtarget)
    beta=1.0d0/(1.0d0+rho)
    sigma_A=sigma_A+0.5*sigma_A*(Hginitarget/Hgini-1.0d0)
    !===============================
    endif

enddo ! calibation iteration    
    
    
close(51)
print*,'======== calibration converged ========='

open(unit=400,file='resut_CE.txt',status='replace') 
write(400,*) 'beta=', beta
write(400,*) 'sigmaA=', sigma_A
write(400,*) 'sigmaeta=', sigma_eta
write(400,*) 'phi=', phi
write(400,*) 'deltah=', deltah
write(400,*) 'meanA=', meanA

write(400,*) 'steady state'
write(400,*) 'Hss=', Hss
write(400,*) 'xhss=', xhss 
write(400,*) 'Kss=', Kss
write(400,*) 'rss=', rss 
write(400,*) 'Yss=', Yss

Hnew=sum(H_real(:,TT+1:T))/real(N*(T-TT))

print*, 'equilibrium r=', r
print*, 'equilibrium w=', w
print*, 'equilibrium K=', Knew 
print*, 'equilibrium H=', Hnew 

write(400,*) 'CE'
write(400,*) 'equilibrium r=', r
write(400,*) 'equilibrium w=', w
write(400,*) 'equilibrium K=', Knew
write(400,*) 'equilibrium H=', Hnew 

! computation of GIni coefficients
print*, 'Computing Gini indenxes'
call Gini
write(400,*) 'KGini=', KGini, ' HGini=', HGini, 'CV=', CV

print*, 'Computing correlation'
call corrkh
write(400,*) 'corr=', corr_kh  

print*, 'computing relative poornees of consumption poor'
call relativepoornees
write(400,*) 'bottom 5: k/K =', relative_k05, 'h/H=', relative_h05
write(400,*) 'bottom 10: k/K =', relative_k10, 'h/H=', relative_h10
write(400,*) 'bottom 20: k/K =', relative_k20, 'h/H=', relative_h20

maxK_real=maxval(K_real(:,T))
maxH_real=maxval(H_real(:,T))
print*, 'maxK=', maxK_real, 'maxH=', maxH_real
write(400,*) 'maxK=', maxK_real, 'maxH=', maxH_real

do i1=1,T
    mean_Kreal(i1)=sum(K_real(:,i1))/real(N)
    mean_Hreal(i1)=sum(H_real(:,i1))/real(N)
enddo


close(400)


print*, 'start saving results'

open(unit=33,file='K.txt',status='replace')
     write(33,'(1f20.10)') Knew
close(33)  

open(unit=34,file='H.txt',status='replace')
     write(34,'(1f20.10)') Hnew
close(34)

open(unit=35,file='calibration.txt',status='replace')
     write(35,*) 'beta=', beta, 'sigma_A=', sigma_A
close(35)

print*, 'end of the program'
end program
