subroutine relativepoornees
    
use global
use qsort_c_module
    
integer:: j05, j10, j20, i1
real:: consumption(N)
real(8):: c05, c10, c20, wealth(N), earning(N) 
real(8):: kav05, hav05, kav10, hav10, kav20, hav20, kav, hav


consumption=C_real(:,T)
call QsortC(consumption)

! cutoff
j05 = N/20
c05 = (consumption(j05)+consumption(j05+1))*0.5d0
j10 = N/10
c10 = (consumption(j10)+consumption(j10+1))*0.5d0
j20 = N/5
c20 = (consumption(j20)+consumption(j20+1))*0.5d0

consumption=C_real(:,T)
wealth=K_real(:,T)
earning=H_real(:,T)

kav05 = sum(wealth, mask = consumption < c05)/ count(consumption < c05)
hav05 = sum(earning, mask = consumption < c05)/ count(consumption < c05)

kav10 = sum(wealth, mask = consumption < c10)/ count(consumption < c10)
hav10 = sum(earning, mask = consumption < c10)/ count(consumption < c10)

kav20 = sum(wealth, mask = consumption < c20)/ count(consumption < c20)
hav20 = sum(earning, mask = consumption < c20)/ count(consumption < c20)

kav = sum(wealth)/real(N)
hav = sum(earning)/real(N)

relative_k05 = kav05/kav
relative_h05 = hav05/hav
relative_k10 = kav10/kav
relative_h10 = hav10/hav
relative_k20 = kav20/kav
relative_h20 = hav20/hav
    
print*, 'bottom 5: k/K =', relative_k05, 'h/H=', relative_h05
print*, 'bottom 10: k/K =', relative_k10, 'h/H=', relative_h10
print*, 'bottom 20: k/K =', relative_k20, 'h/H=', relative_h20
    
end subroutine
    