subroutine xhsolversec(xh0,xh1,xxh,fflag,A,h,indA,indk)

use global
use mod_functions

implicit none

real(8), intent(inout):: xh0, xh1
real(8), intent(out):: xxh
integer, intent(out):: fflag
real(8), intent(in):: A,h
integer, intent(in):: indA, indk

real(8):: fxh0, fxh1, fxh, dx
integer:: go_on_ssec, iter

go_on_ssec=1
fxh0=Eulerxh(xh0,A,h,indA,indk)
fxh1=Eulerxh(xh1,A,h,indA,indk)

if (dabs(fxh1)<dabs(fxh0)) then
    xxh=xh1
    fxh=fxh1
else
    xxh=xh0
    fxh=fxh0
    xh0=xh1
    fxh0=fxh1
endif

if (dabs(fxh)<tol1) then
    fflag=0
    go_on_ssec=0
endif

iter=0

do while (go_on_ssec==1)
    iter=iter+1
    
    dx=-fxh*(xh0-xxh)/(fxh0-fxh)
    xh0=xxh
    fxh0=fxh
    xxh=xxh+dx
    
    if (xxh<=0) then
        fflag=1
        go_on_ssec=0
    endif
    
    fxh=Eulerxh(xxh,A,h,indA,indk)
    
    if (dabs(fxh)<tol1 .and. xxh>0 ) then
        go_on_ssec=0
        fflag=0
    endif
    
    if (iter>100) then
        go_on_ssec=0
        fflag=1
    endif
    
enddo

end subroutine