subroutine HHproblem

use global
use mod_functions

implicit none

real(8):: ctmp, cbdd, xxh
integer:: j1, j2, j3, go_on_pol, iter_pol
real(8):: polknew(dimgridk,dimgridh,ngrid), polxhnew(dimgridk,dimgridh,ngrid)
real(8):: dval1new(dimgridk,dimgridh,ngrid), dval2new(dimgridk,dimgridh,ngrid)
real(8):: polkend(dimgridk,dimgridh,ngrid), polxhend(dimgridk,dimgridh,ngrid), kgridend(dimgridk,dimgridh,ngrid)
real(8):: xh0, xhlow, xhup, xhold, xholdold, xh1, hptmp, hp
integer:: i1
real(8):: dval1next, dval1onh(dimgridh), Edval1next, cc, kk, kink, ghgxh
real(8):: diff, diff1, diff2, diffk, diffxh

integer:: indA, indk, fflag
real(8):: A,k,h,kprime,xh

!checking gap
integer:: kchk1, kchk2, hchk 

kchk1=3 
kchk2=dimgridk-3 
hchk=dimgridh-3

print*,'start policy functioniteration'

go_on_pol=1
iter_pol=0
diff=100.0   

do while (go_on_pol==1)
    iter_pol=iter_pol+1
    
    print*,'=========== iter_pol=', iter_pol,' ============'
    
        !$OMP PARALLEL PRIVATE(j3,j1,j2,h,A,kprime,indA,indk,xh0,xh1,xxh,xh,fflag,hptmp,Edval1next,i1,hp,dval1onh,dval1next,cc,kk)
        
        !$OMP DO
    
        do j3=1,dimgridh
            h=hgrid(j3)
            !print*,'===i_h=', j3, ' ==='
      
            do j1=1,ngrid
                A=Ability(j1)
                indA=j1
                !print*, '=====i_A=', j1,' ====='
 
                do j2=dimgridk,1,-1
                    kprime=kgrid(j2)
                    indk=j2
                
                    xh0=polxhendold(j2,j3,j1)
                    xh1=1.01*xh0
                    call xhsolversec(xh0,xh1,xxh,fflag,A,h,indA,indk)
                
                    if (fflag == 0) then
                        xh=xxh
                    
                        if (xh<=0) then
                            print*,'xh is out of range (secant solver) with xh=',xh
                        endif

                    else
                        xh0=polxhendold(j2,j3,j1)
                        call fmincon(xh0,xxh,A,h,indA,indk)
                        xh=xxh
                    
                        if (xh<=0) then
                            print*,'xh is out of range (golden) with xh=',xh
                        endif
                
                    endif
                
                !print*,'i_k=',j2, ' xh=',xh
 
                
                    hptmp=(1-deltah)*h+A*xh**phi*h**phi
                    Edval1next=0.0d0
                    do i1=1,ngrid
                        hp=etashock(i1)*hptmp
                        dval1onh=dval1(j2,:,j1)
                        dval1next=interp1nu(dimgridh,hgrid,dval1onh,hp)
                        Edval1next=Edval1next+etashockprob(i1)*dval1next
                    enddo
                
                    cc=(beta*Edval1next)**(-1.0d0/sigma)
                    cc=max(cc,0.001)
                    kk=(cc-h*w+kprime+xh)/(1.0d0+r)
                
                    kgridend(j2,j3,j1)=kk
                    polkend(j2,j3,j1)=kprime
                    polxhend(j2,j3,j1)=xh
                
                       
                enddo    
         
            enddo
    
        enddo
        
        !$OMP END DO
        
        !$OMP END PARALLEL  
    
    !pause
    
    print*,'interpolation on kgrid and evaluating dvals'
    
    !$OMP PARALLEL PRIVATE(j3,j1,j2,h,A,indA,kink,k,indk,kprime,xh0,xxh,fflag,ctmp,cbdd,ghgxh)
        
    !$OMP DO
    
    do j3=1,dimgridh
            h=hgrid(j3)
    
        do j1=1,ngrid
            A=Ability(j1)
            indA=j1
            kink=kgridend(1,j3,j1)

            do j2=dimgridk,1,-1
                k=kgrid(j2)
                indk=j2
                if (k>kink) then
                
                    if (k < kgridend(dimgridk,j3,j1)) then
                    
                        polknew(j2,j3,j1)=interp1nu(dimgridk,kgridend(:,j3,j1),polkend(:,j3,j1),k)
                        polxhnew(j2,j3,j1)=interp1nu(dimgridk,kgridend(:,j3,j1),polxhend(:,j3,j1),k)
                    
                        if (polxhnew(j2,j3,j1)<=0) then
                            print*,'polxhnew is out of range (interpolation) with xh=',polxhnew(j2,j3,j1)
                            print*, 'j2=',j2,'j3=',j3,'j1=',j1
                        endif
                        if (polknew(j2,j3,j1)<0) then
                            print*,'polknew is out of range (interpolation) with k=',polknew(j2,j3,j1)
                            print*, 'j2=',j2,'j3=',j3,'j1=',j1
                        endif    
                    else
                    
                        polknew(j2,j3,j1)=interp1nu(dimgridk,kgridend(:,j3,j1),polkend(:,j3,j1),k)
                        kprime=polknew(j2,j3,j1)
                        
                        if (j2==dimgridk) then
                            xh0=polxhend(j2,j3,j1)
                        else
                            xh0=polxhnew(j2+1,j3,j1)
                        endif
                        
                        call interpsolver(xh0,xxh,fflag,A,h,k,kprime,indA)
                        
                        if (fflag==0) then
                            polxhnew(j2,j3,j1)=xxh
                                                  
                            if (polxhnew(j2,j3,j1)<=0) then
                              print*,'polxhnew is out of range (kinksolver_secant) with xh=',polxhnew(j2,j3,j1)
                            endif 
                        else
                            if (j2==dimgridk) then
                                xh0=polxhend(j2,j3,j1)
                            else
                                xh0=polxhnew(j2+1,j3,j1)
                            endif
                        
                            call fmincon3(xh0,xxh,A,h,k,kprime,indA)
                            polxhnew(j2,j3,j1)=xxh
                        
                            if (polxhnew(j2,j3,j1)<=0.0d0) then
                               print*,'polxhnew is out of range (gondensearch) with xh=',polxhnew(j2,j3,j1)
                            endif             
                        endif

                    endif                
                
                else
                    polknew(j2,j3,j1)=0.0d0
                    
                    if (j2==dimgridk) then
                        xh0=polxhend(j2,j3,j1)
                    else
                        xh0=polxhnew(j2+1,j3,j1)
                    endif
                    
                    call kinksolver(xh0,xxh,fflag,A,h,k,indA)
                    
                    if (fflag==0) then
                        polxhnew(j2,j3,j1)=xxh
                                                  
                        if (polxhnew(j2,j3,j1)<=0) then
                          print*,'polxhnew is out of range (kinksolver_secant) with xh=',polxhnew(j2,j3,j1)
                        endif 
                         
                    else
                        if (j2==dimgridk) then
                            xh0=polxhend(j2,j3,j1)
                        else
                            xh0=polxhnew(j2+1,j3,j1)
                        endif
                        
                        call fmincon2(xh0,xxh,A,h,k,indA)
                        polxhnew(j2,j3,j1)=xxh
                        
                        
                        if (polxhnew(j2,j3,j1)<=0 ) then
                           print*,'polxhnew is out of range (gondensearch) with xh=',polxhnew(j2,j3,j1)
                        endif
                    
                    
                    
                    endif
                endif
                        
                
                polh(j2,j3,j1)=(1.0d0-deltah)*h+A*h**phi*polxhnew(j2,j3,j1)**phi
                ctmp=k*(1.0d0+r)+h*w-polknew(j2,j3,j1)-polxhnew(j2,j3,j1)
                cbdd=max(0.0001,ctmp)
                dval1new(j2,j3,j1)=(1.0d0+r)*cbdd**(-sigma) + ddeltak
                ghgxh=(1.0d0-deltah+A*phi*h**(phi-1.0d0)*polxhnew(j2,j3,j1)**phi)/(A*phi*h**phi*polxhnew(j2,j3,j1)**(phi-1.0d0))
                dval2new(j2,j3,j1)=(w+ghgxh)*cbdd**(-sigma) + ddeltah
            
                
            enddo
            
        enddo
    enddo
    
   !$OMP END DO
        
   !$OMP END PARALLEL
    
    
    
    diff1=maxval(dabs(dval1new(kchk1:kchk2,1:hchk,:)-dval1(kchk1:kchk2,1:hchk,:)))/maxval(dabs(dval1(kchk1:kchk2,1:hchk,:)))
    diff1=maxval(dabs(dval2new(kchk1:kchk2,1:hchk,:)-dval2(kchk1:kchk2,1:hchk,:)))/maxval(dabs(dval2(kchk1:kchk2,1:hchk,:)))
    
    diffk=maxval(dabs(polknew(kchk1:kchk2,1:hchk,:)-polk(kchk1:kchk2,1:hchk,:)))
    diffxh=maxval(dabs(polxhnew(kchk1:kchk2,1:hchk,:)-polxh(kchk1:kchk2,1:hchk,:)))
    
    diff=max(diffk,diffxh)
    
    !print*, 'diff1=', diff1, ' diff2=', diff2
    print*, 'diffk=', diffk, ' diffxh=', diffxh  
    write(51,*) 'iter_pol=', iter_pol,'diffk=', diffk, ' diffxh=', diffxh 
    
    if (diff<tol2) then
        go_on_pol=0
    endif
    
    
        polk=polknew
        polxh=polxhnew    
        dval1=dval1new
        dval2=dval2new
        polxhendold=polxhend 
           

enddo
        
print*, 'policy function successfully converged'  


open(unit=3,file='polk.txt',status='replace')
     write(3,'(1f20.15)') polk
close(3)

open(unit=4,file='polxh.txt',status='replace')
     write(4,'(1f20.15)') polxh
close(4)

open(unit=5,file='polh.txt',status='replace')
     write(5,'(1f20.15)') polh
close(5)      
        
open(unit=6,file='dval1.txt',status='replace')
     write(6,'(1f20.15)') dval1
close(6) 

open(unit=7,file='dval2.txt',status='replace')
     write(7,'(1f20.15)') dval2
close(7)     

open(unit=8,file='polxhendold.txt',status='replace')
     write(8,'(1f20.15)') polxhendold
close(8)  



end subroutine