subroutine fmincon2(xh0,xxh,A,h,k,indA)

use mod_functions


implicit none

real(8), intent(in):: xh0
real(8), intent(out):: xxh
real(8), intent(in):: A,h,k
integer, intent(in):: indA


real(8):: xl, xu

integer(4) i
real(8) tol, p, q, aa, bb, c, d, fb, fc, test(1:2) 

xl=0.0
xu=1.5*xh0

!C Compute the parameters of the problem */
	tol=dsqrt(Epsilon(tol))
	p=0.5d0*(dsqrt(5.d0)-1.d0)
	q=1.d0-p

!C Compute the initial interval [aa,d] and the points bb and c that divide it

	aa=xl
	d=xu
	bb=p*aa+q*d
	c=q*aa+p*d

!C Compute the function value at bb and c 
	fb=Eulerkinksquare(bb,A,h,k,indA)
	fc=Eulerkinksquare(c,A,h,k,indA)
   
!C Iterate so that the inverval gets small and smaller
	test(1)=1
	test(2)=dabs(aa)+dabs(c)
	
    print*, 'golden search'

	do while (dabs(d-aa).gt.tol*MaxVal(test))
		if (fb.lt.fc) then ! choose [bb,d] as next interval
			aa=bb         
			bb=c
			fb=fc
			c=p*bb+q*d
			fc=Eulerkinksquare(c,A,h,k,indA)
		else ! choose [aa,c] as next interval
			d=c
			c=bb
			fc=fb
			bb=p*c + q*aa
			fb=Eulerkinksquare(bb,A,h,k,indA)
		endif
		test(2)=dabs(aa)+dabs(c)
	End Do

	if (fb.gt.fc) then
		xxh=bb
	else
		xxh=c
	endif


end subroutine