module global
! parameters
!=============================================================================================
real(8), parameter:: sigma=2.0d0, beta=0.940576010741344d0, alpha=0.36d0, deltak=0.08d0, phi=0.40d0, deltah=0.04d0
!=============================================================================================

!================================================================================================================
real(8), parameter:: sigma_A=0.147944935929239d0
!================================================================================================================

! tolerances for ssolver and policy function convergence
real(8), parameter:: tol1=10.E-10, tol2=50.E-7, tol3=10.E-7    ! tol1: for ssolver,  tol2: for policy function convergence

! global variables 
! global variables 
real(8):: mu_A, meanA, sigma_eta, KLratio, w, r,  B, rnew, Knew, Hnew, KLrationew, ddeltak, ddeltah, ddeltaknew, ddeltahnew
real(8):: Xhnew
real(8):: gapgrr

! grid of k and h   &  grid of shock and ability
real(8), parameter:: hmin=0.1, kmin=0.0     ! hmax=12.0 ! kmax=165.0
real(8):: hmax, kmax

integer:: dimgridk, dimgridh
integer, parameter:: ngrid=3
real(8), allocatable, dimension(:):: kgrid, hgrid
real(8):: Ability(ngrid), etashock(ngrid),etashockprob(ngrid)
real(8), allocatable, dimension(:,:,:):: polk, polxh, polh, polxhendold, dval1, dval2

!steady-state
real(8):: Hss, rss, Kss, wss, xhss, Yss

!simulation for aggregation
integer, parameter:: T=5000, N=10000, TT=2000, NT=N*(T+1)
real(8):: eta_real(N,T+1)
real(8),allocatable, dimension(:,:) :: K_real, H_real, Xh_real
real(8),allocatable, dimension(:,:) :: Welfare_real, ddeltak_real, ddeltah_real
real(8),allocatable, dimension(:) :: KKTT, HHTT, XXhTT
integer:: A_index(N)
real(8):: ushock(N,T+1)

real(8):: KGini, HGini, CV, corr_kh


end module