subroutine genability

use global
use probability
implicit none

real(8):: minab, maxab, ab(ngrid), midab(ngrid-1), cumprobab(ngrid), probab
integer:: i1,i2 , ntype(ngrid), starta, enda


minab=mu_A-1.8*sigma_A
maxab=mu_A+1.8*sigma_A

do i1=1,ngrid
    ab(i1)=minab+((maxab-minab)/(ngrid-1.0))*(i1-1)
enddo

do i1=1,ngrid-1
    midab(i1)=(ab(i1+1)+ab(i1))/2.0
enddo

do i1=1,ngrid-1
    if (sigma_A>0) then
        cumprobab(i1)=NORMCDF((midab(i1)-mu_A)/sigma_A,0.0d0,1.0d0)
    else
        cumprobab(i1)=1.0d0
    endif
enddo
cumprobab(ngrid)=1.0

Ability=dexp(ab)

!print*,'ability='
!print*, Ability

!print*, cumprobab

ntype(1)=floor(N*cumprobab(1))
if (N*cumprobab(1)-ntype(1)>0.5) ntype(1)=ntype(1)+1
do i1=2,ngrid-1    
    probab=cumprobab(i1)-cumprobab(i1-1)
    ntype(i1)=floor(N*probab)
    if (N*probab-ntype(i1)>0.5) ntype(i1)=ntype(i1)+1
enddo
ntype(ngrid)=N-sum(ntype(1:ngrid-1))


A_index(1:ntype(1))=1
do i1=2,ngrid
    starta=sum(ntype(1:i1-1))+1
    enda=sum(ntype(1:i1))
    A_index(starta:enda)=i1
enddo

open(unit=10, file='Ability.txt')
  write(10,'(1f14.7)') Ability
close(10)

!open(unit=40, file='A_index.txt')
!  write(40,'(1f14.7)') real(A_index)
!close(40)

end subroutine