program humanK

use global
use mod_functions

implicit none

real(8):: gapr, gapdeltak, gapdeltah, gapmax, Kagg, Hagg, ww, maxKLratio, minKLratio, gapKLratio, KLratioold
real(8):: rCE, wCE
real(8):: KLratioCE, scale
real(8):: ddeltakCE, ddeltahCE
real(8):: ctmp, cbdd, xh1
integer:: j1, j2, j3
integer:: go_on_price, iter_price, nsteps
integer:: dimgridkpre, dimgridhpre
integer:: NN
real(8):: DSEED, ushocktmp(NT), maxK_real, maxH_real, mean_Kreal(T), mean_Hreal(T)
real(8), allocatable, dimension(:):: polktmp, polxhtmp, polxhendoldtmp, polhtmp, dval1tmp, dval2tmp
real(8), allocatable, dimension(:):: kgridold, polhonk, polkonk, polxhonk, polxhendoldonk, dval1onk, dval2onk
real(8), allocatable, dimension(:):: kgridpre, hgridpre
real(8), allocatable, dimension(:,:,:):: polhpre, polkpre, polxhpre, dval1pre, dval2pre, polxhendoldpre

real(8):: A,k,h

real(8):: fr, fup, rlow, rup, rnext, frnext, grr, grrlow, grrup, fixKLratio, rold
integer:: mode, mode2

real(8):: xh0, xxh, thetanew, ghgxh
integer:: fflag 

real(8):: ddeltakold, rrold, KLold, wold, ddeltahold, ghgxhold 
real(8):: gridparam

integer:: go_on_planner, iter_planner
real(8):: gapddeltak
 

print*, 'starting steady state computation for initial guess'
open(unit=51,file='logfile.txt',status='replace')
open(unit=400,file='result.txt',status='replace')

!===========================================================
! solve for meanA to match Yss=1.0
!===========================================================
print*, 'Start solving for meanA'
call meanAsolver
print*,''
print*,'meanA=', meanA
print*, ''
! mean of log(A)
mu_A=dlog(meanA)-0.5*sigma_A**2.0

!==============================
! sigma_eta (variance of shock)
!==============================
sigma_eta=0.111d0 !0.111d0
!========================

call steadystate
call genability


! shock generation for the eta shock
DSEED=3243090.0D+00
call GGUBS(DSEED,NT,ushocktmp)
ushock=reshape(ushocktmp,(/N, T+1/))
print*, 'shock generated'

allocate(K_real(N,T+1))
allocate(H_real(N,T+1))
allocate(Xh_real(N,T+1))
allocate(ddeltak_real(N,T))
allocate(ddeltah_real(N,T))
allocate(Welfare_real(N,T))


call genetashock

        
    !=========================================================================        
    !loading the initial guess from the grid search 
    !=========================================================================
     ddeltakCE = 0.378218147072434d0  
     scale = 0.2458d0    
     ddeltak=scale*ddeltakCE 
     r=-0.016478d0
    !=================================
    ! hmax kmax of the previous result
    !=================================
      hmax=18.0d0
      kmax=300.0d0
      dimgridk=250 
      dimgridh=400
    !=================================

    allocate(kgrid(dimgridk),hgrid(dimgridh))

    allocate(polktmp(dimgridk*dimgridh*ngrid),polxhtmp(dimgridk*dimgridh*ngrid))
    allocate(polxhendoldtmp(dimgridk*dimgridh*ngrid),polhtmp(dimgridk*dimgridh*ngrid))
    allocate(dval1tmp(dimgridk*dimgridh*ngrid),dval2tmp(dimgridk*dimgridh*ngrid)) 

    allocate(polk(dimgridk,dimgridh,ngrid),polxh(dimgridk,dimgridh,ngrid))
    allocate(polh(dimgridk,dimgridh,ngrid),polxhendold(dimgridk,dimgridh,ngrid))
    allocate(dval1(dimgridk,dimgridh,ngrid),dval2(dimgridk,dimgridh,ngrid))

    print*, 'grid generation for previous result'
    call getgrid
    !gridparam = 0.8d0  !k = 1 is linear, k = 0 is L-shaped
    !call PowerSpacedGrid (dimgridk,gridparam,kmin,kmax,kgrid)
    !call PowerSpacedGrid (dimgridh,gridparam,hmin,hmax,hgrid)
    
    open(unit=99,file='polh.txt',status='old')
         read(99,*) polhtmp     
    close(99)
    open(unit=100,file='polk.txt',status='old')
         read(100,*) polktmp     
    close(100)
    open(unit=101,file='polxh.txt',status='old')
         read(101,*) polxhtmp     
    close(101)
    open(unit=102,file='dval1.txt',status='old')
         read(102,*) dval1tmp     
    close(102)
    open(unit=102,file='dval2.txt',status='old')
         read(102,*) dval2tmp     
    close(102)
    open(unit=104,file='polxhendold.txt',status='old')
         read(104,*) polxhendoldtmp     
    close(104)
    
    polh=RESHAPE (polhtmp, (/dimgridk, dimgridh, ngrid/))
    polk=RESHAPE (polktmp, (/dimgridk, dimgridh, ngrid/))
    polxh=RESHAPE (polxhtmp, (/dimgridk, dimgridh, ngrid/))
    dval1=RESHAPE (dval1tmp, (/dimgridk, dimgridh, ngrid/))
    dval2=RESHAPE (dval2tmp, (/dimgridk, dimgridh, ngrid/))
    polxhendold=RESHAPE (polxhendoldtmp, (/dimgridk, dimgridh, ngrid/))
    
    
!!=========================================================================        
!!  Interpolation on new grid   
!!=================================
!    allocate(kgridpre(dimgridk),hgridpre(dimgridh))
!    allocate(polhpre(dimgridk,dimgridh,ngrid),polkpre(dimgridk,dimgridh,ngrid))
!    allocate(polxhpre(dimgridk,dimgridh,ngrid),polxhendoldpre(dimgridk,dimgridh,ngrid))
!    allocate(dval1pre(dimgridk,dimgridh,ngrid),dval2pre(dimgridk,dimgridh,ngrid)) 
!
!    dimgridkpre = dimgridk
!    dimgridhpre = dimgridh
!
!    kgridpre = kgrid
!    hgridpre = hgrid
!    polkpre = polk
!    polhpre = polh
!    polxhpre = polxh
!    polxhendoldpre = polxhendold
!    dval1pre = dval1
!    dval2pre = dval2
!    
!    deallocate(kgrid,hgrid,polk,polxh,polh,polxhendold,dval1,dval2) 
!    deallocate(polktmp,polxhtmp,polxhendoldtmp,polhtmp,dval1tmp,dval2tmp)
!    
!! New hmax kmax designation
!!=================================
!  hmax=18.0d0   !30
!  kmax=300.0d0 !800
!  dimgridk=250 
!  dimgridh=400
!!=================================
!
!allocate(kgrid(dimgridk),hgrid(dimgridh))
!
!print*, 'grid generation for new grid'
!call getgrid
!!gridparam = 0.8d0  !k = 1 is linear, k = 0 is L-shaped
!!call PowerSpacedGrid (dimgridk,gridparam,kmin,kmax,kgrid)
!!call PowerSpacedGrid (dimgridh,gridparam,hmin,hmax,hgrid)
!
!allocate(polk(dimgridk,dimgridh,ngrid),polxh(dimgridk,dimgridh,ngrid))
!allocate(polh(dimgridk,dimgridh,ngrid),polxhendold(dimgridk,dimgridh,ngrid))
!allocate(dval1(dimgridk,dimgridh,ngrid),dval2(dimgridk,dimgridh,ngrid))
!
!allocate(kgridold(dimgridk),polhonk(dimgridk))
!allocate(polkonk(dimgridk),polxhonk(dimgridk))
!allocate(dval1onk(dimgridk),dval2onk(dimgridk)) 
!allocate(polxhendoldonk(dimgridk))
!
!print*,''
!print*, 'interpolation on new grid'
!print*,''
!do j2=1,dimgridk
!    do j3=1,dimgridh
!        do j1=1,ngrid
!        
!            polk(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,polkpre(:,:,j1),kgrid(j2),hgrid(j3))    
!            polxhendold(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,polxhendoldpre(:,:,j1),kgrid(j2),hgrid(j3)) 
!            polh(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,polhpre(:,:,j1),kgrid(j2),hgrid(j3))  
!            polxh(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,polxhpre(:,:,j1),kgrid(j2),hgrid(j3)) 
!            dval1(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,dval1pre(:,:,j1),kgrid(j2),hgrid(j3)) 
!            dval2(j2,j3,j1)=interp2nu(dimgridkpre,dimgridhpre,kgridpre,hgridpre,dval2pre(:,:,j1),kgrid(j2),hgrid(j3)) 
!
!        enddo
!    enddo    
!enddo
!
!deallocate(polkpre,polhpre,polxhendoldpre,polxhpre,dval1pre,dval2pre)
!!================================================================================================
    

print*, 'Starting finding ddeltak '
go_on_planner=1
iter_planner=0
gapddeltak=100.0    
    
do while (go_on_planner==1)      
        
    iter_planner = iter_planner +1
        
    print*, '=========== ddeltak_iter=', iter_planner, ' ==========='
    write(51,*) '==========  ddeltak_iter=', iter_planner, '==========='
        
    KLratio = ((r + deltak)/alpha)**(1.0d0/(alpha-1.0d0))
    write(51,*) 'ddeltak=', ddeltak
    write(400,*) 'ddeltak=', ddeltak
        
    go_on_price=1
    iter_price=0
    gapr=100.0d0
    gapgrr=100.0d0
        
    do while (go_on_price==1)
        
        iter_price = iter_price+1
            
        ddeltah=-1.0d0*ddeltak*KLratio
            
        w=B*(1.0-alpha)*KLratio**alpha
        r=B*alpha*KLratio**(alpha-1.0)-deltak    

        grr = 1.0d0 + r
            
        print*, '=========', iter_planner, 'iter_price=', iter_price
        write(51,*) '=========', iter_planner, 'iter_price=', iter_price   
        write(400,*) '=========', iter_planner, 'iter_price=', iter_price  

        !===========================================================
        !  SPP policy function solving and compute ddeltak ddeltah
        !===========================================================
             
            print*, ' '
            print*, 'with prices  ','w=', w, ' r=', r 
            write(51,*) 'with prices  ','w=', w, ' r=', r

            call HHproblem
            call Aggregate
    
            print*, 'Knew=', Knew, 'Hnew=', Hnew
            print*, 'Xhnew=', Xhnew
            print*, 'KLratio=', KLratio, ' KLrationew=', KLrationew
            print*, 'r=', r, ' rnew=', rnew
                
            write(51,*) 'Knew=', Knew, 'Hnew=', Hnew
            write(51,*) 'Xhnew=', Xhnew
            write(51,*) 'KLratio=', KLratio, ' KLrationew=', KLrationew
            write(51,*) 'r=', r, ' rnew=', rnew
                
            write(400,*) 'Knew=', Knew, 'Hnew=', Hnew
            write(400,*) 'Xhnew=', Xhnew
            write(400,*) 'KLratio=', KLratio, ' KLrationew=', KLrationew
            write(400,*) 'r=', r, ' rnew=', rnew
            
            gapgrr = dabs(r-rnew)/(0.5d0*dabs(2.0d0+r+rnew))
                
            print*, ' gapgrr=', gapgrr
            write(51,*) ' gapgrr=', gapgrr
            write(400,*) ' gapgrr=', gapgrr
                
            !go_on_price = 0
            if (gapgrr<tol3) then
                go_on_price = 0
            endif
                
            if (iter_price > 30) then
                exit
            endif
                
            !**** Updating KLratio and ddeltah *******
            KLratioold = KLratio
            rold = r
            KLratio = 0.90d0*KLratio + 0.10d0*KLrationew 
                
    enddo     ! search over prices

        
    maxK_real = maxval(K_real(:,T))
    maxH_real = maxval(H_real(:,T))
        
    print*, '==== price converged ======'
    print*, 'ddeltak=', ddeltak, ' ddeltaknew=', ddeltaknew
    print*, 'ddeltah=', ddeltah, ' ddeltahnew=', ddeltahnew
    print*, 'req=', r, ' KLratio=', KLratioold
    print*, 'ddeltakgap=', ddeltaknew-ddeltak
    
    write(51,*) '==== price converged ======'
    write(51,*) 'ddeltak=', ddeltak, ' ddeltaknew=', ddeltaknew
    write(51,*) 'ddeltah=', ddeltah, ' ddeltahnew=', ddeltahnew
    write(51,*) 'req=', r, ' KLratio=', KLratioold
    write(51,*) 'ddeltakgap=', ddeltaknew-ddeltak
   
    ! check if gapddeltak is small enough
    gapddeltak=dabs(ddeltaknew-ddeltak)
    
    print*, 'gapddeltak=', gapddeltak
    write(51,*) 'gapddeltak=', gapddeltak
    
    
    if (gapddeltak < 0.00001d0) then
        go_on_planner=0
    else
        !===============================
        !updatingddeltak
        !===============================
        ddeltak = 0.8d0*ddeltak+0.2d0*ddeltaknew
    endif
    
enddo  ! search over ddeltak 

! computation of GIni coefficients
    print*, 'Computing Gini indenxes'
    call Gini

  close(51)

    write(400,*) '=====  ddeltak converged ========'
    write(400,*) 'ddeltak0=', ddeltak
    write(400,*) 'req=', rold
    write(400,*) 'ddeltah0=', ddeltah
    write(400,*) 'ddeltak=', ddeltaknew
    write(400,*) 'ddeltah=', ddeltahnew
    write(400,*) 'gapddeltak=', ddeltaknew-ddeltak
    write(400,*) 'gapddeltah=', ddeltahnew-ddeltah
    write(400,*) 'K=', Knew
    write(400,*) 'H=', Hnew
    write(400,*) 'KLratio=', KLratioold
    write(400,*) 'maxh=', maxK_real
    write(400,*) 'maxk=', maxH_real
    write(400,*) 'KGini=', KGini
    write(400,*) 'HGini=', HGini
    write(400,*) 'CV=', CV

close(400)


print*, 'end of the program'
end program
