subroutine kinksolver(xh0,xxh,fflag,A,h,k,indA)

use global
use mod_functions

implicit none

real(8), intent(inout)::xh0
real(8), intent(out)::xxh
integer, intent(out):: fflag
real(8), intent(in):: A,h,k
integer, intent(in):: indA

real(8):: fxh0, fxh1,fxh,xh1,dx
integer:: go_on_ssec, iter

xh1=1.01*xh0
go_on_ssec=1

fxh0=Eulerkink(xh0,A,h,k,indA)
fxh1=Eulerkink(xh1,A,h,k,indA)

if (dabs(fxh1)<dabs(fxh0)) then
    xxh=xh1
    fxh=fxh1
else
    xxh=xh0
    fxh=fxh0
    xh0=xh1
    fxh0=fxh1
endif

if (dabs(fxh)<tol1) then
    fflag=0
    go_on_ssec=0
endif

iter=0

do while (go_on_ssec==1)
    iter=iter+1
    dx=-fxh*(xh0-xxh)/(fxh0-fxh)
    xh0=xxh
    fxh0=fxh
    xxh=xxh+dx
    
    if (xxh<=0 ) then
        fflag=1
        go_on_ssec=0
    endif
    
    fxh=Eulerkink(xxh,A,h,k,indA)
    
    if (dabs(fxh) < tol1) then
        fflag=0
        go_on_ssec=0
    endif
    
    if (iter>100) then
        fflag=1
        go_on_ssec=0
    endif
    
enddo

end subroutine
            