subroutine xhsolver(xhlow,xhup,xh0,xxh,fflag,A,h,indA,indk)

use global
use mod_functions

implicit none

real(8), intent(inout):: xhlow, xhup, xh0
real(8), intent(out):: xxh
integer, intent(out):: fflag
real(8), intent(in):: A,h
integer, intent(in):: indA, indk

integer:: go_on_bisec, iter
real(8):: fxhlow, fxhup, fxh

go_on_bisec=1
fxhlow=Eulerxh(xhlow,A,h,indA,indk)   
fxhup=Eulerxh(xhup,A,h,indA,indk)



if (fxhlow*fxhup>0) then
    xhlow=0.95*xh0
    xhup=1.05*xh0
    fxhlow=Eulerxh(xhlow,A,h,indA,indk)
    fxhup=Eulerxh(xhup,A,h,indA,indk)
    
    if (fxhlow*fxhup>0) then 
        xhlow=0.50*xh0
        xhup=1.50*xh0
        fxhlow=Eulerxh(xhlow,A,h,indA,indk);
        fxhup=Eulerxh(xhup,A,h,indA,indk);
        if (fxhlow*fxhup > 0) then
            fflag=1
            go_on_bisec=0 
        endif
    endif
endif



iter=0

do while (go_on_bisec==1)
    iter=iter+1
    xxh=(xhlow+xhup)/2.0
    fxh=Eulerxh(xxh,A,h,indA,indk)
    if (fxhup*fxh<=0) then
        xhlow=xxh
        fxhlow=fxh
    else 
        xhup=xxh
        fxhup=fxh
    endif
    
    if (dabs(fxh)<tol1) then
        fflag=0
        go_on_bisec=0
    endif
    
    if (iter>100) then
        fflag=1
        go_on_bisec=0
    endif
    
!print*,'iter=', iter   
    
enddo

end subroutine